function y = pdist (x, dtype, varargin)

 [nargout,nargin]=argn(0);

  if (nargin < 1)
    error('No input is given!');
  elseif ((nargin > 1)    & ~ type (dtype)==10 | length(dtype)<3)
    error ('Second argument must be either a string having more than 2 characters!');
  end

  if (isempty (x))
    error ('First argument must be a non-empty matrix');
  elseif (length (size (x)) > 2)
    error ('First argument must be 1 or 2 dimensional');
  end
  
   if (nargin < 2)
    dtype = 'euc';
  end
  
    p = 2; 			// default for minkowski
    if (nargin > 2)
       p = varargin(1); 
    end

    lz=size(x,1);
    xc=[];
    yc=[];
    for i=1:lz
        xc=[xc;i*ones(lz-i,1)];
        yc=[yc;(i+1:lz)'];
    end

    x = x';
    dfx = x(:,xc) - x(:,yc);
    dtype = ascii(convstr (dtype));
    dtype=ascii(dtype(1:3));
    select (dtype)
        case 'che' then
    	dfx = x(:,xc) - x(:,yc);
        y = max (abs (dfx), 'r');
        
      case 'cit' then
    	  y = sum (abs (dfx), 1);

  case 'cor' then
        P = nansum(x,1);
        Q=nansum(x.^2,1);
        NM = bool2s(~isnan(x)')*bool2s(~isnan(x));
        x(x~=x) = 0; 
        N=sum(x>0,1);
        CM = x'*x;
        M  = P./N;
        r  = (Q./N- M.*M); 
        xcor = CM./NM - M'*M;
        xcor = xcor./sqrt(r'*r);
        y = 1 - xcor (sub2ind (size (xcor), xc, yc))';   

      case 'cos' then
    	pdx = x(:,xc) .* x(:,yc);
    	wts = nansum (x(:,xc).^2, 1) .* nansum (x(:,yc).^2, 1);
    	y = 1 - sum (pdx,'r') ./ sqrt (wts);

      case 'euc' then
    	  y = sqrt (nansum (dfx.^2, 1));

      case 'ham' then
    	dfx =  (x(:,xc) - x(:,yc))~=0;
    	y = sum (dfx, 1) / size (x,1);

      case 'jac' then
    	dfx =  (dfx)~=0;
    	wts = x(:,xc) | x(:,yc);
    	y =1- sum (dfx & wts, 1) ./ sum (dfx | wts, 1);
       
      case 'mah' then

        x=x';
        mu=repmat(mean(x,'r'),lz,1); //ori x
        vx=(x-mu)'*(x-mu)/(lz-1);
        wts=inv(vx);
   //     disp(wts-wta);
    	y = sqrt (sum ((wts * dfx) .* dfx, 1));

      case 'min' then

    	  y = (sum ((abs (dfx)).^p, 1)).^(1/p);

  case 'seu' then
      x=x';
        wts = inv (diag (nanvar(x, 0,1))); //ori x
    	y = sqrt (sum ((wts * dfx) .* dfx, 1));
      
    else
    error('Unknown Distance type!');
    end

endfunction

