function y=sierra(x,opt)
    [nargout, nargin]=argn(0);
    if length(size(x))==3 then
        error('First input must be a 2-d array!');
    end
    [m,n]=size(x);
    
    x=mat2gray(x);
    if nargin==1 then
        opt=1;
    end
    if opt==1 then
    y=zeros(m,n);
    for i=1:m
        for j=1:n
            if x(i,j)>0.5 then
                y(i,j)=1;
            end
            e=x(i,j)-y(i,j);
            if j<n then
                x(i,j+1)=x(i,j+1)+e/2;
            end
            if i<m & j>1 then
                x(i+1, j-1)=x(i+1,j-1)+e/4;
            end
            if i<m  then
                x(i+1,j)=x(i+1,j)+e/4;
            end
        end
    end
else
    if opt==2 then
        f=[0 0 0 0 0;
           0 0 0 4 3; 
           1 2 3 2 1]/16;
    elseif opt==3
        f=[ 0 0 0 0 0;
            0 0 0 0 0;
            0 0 0 5 3;
            2 4 5 4 2;
            0 2 3 2 0]/32;
    else
        error('The second prameter must be inclusively between 1 and 3!');
    end
    [m1,n1]=size(f);
     m1=floor(m1/2);
     n1=floor(n1/2);
     x=padding(x,[m1,n1],'z');
    for i=m1+1:m+m1
        for j=n1+1:n+n1
            x(i-m1:i+m1, j-n1:j+n1)=x(i-m1:i+m1, j-n1:j+n1) + f*(x(i,j)-double(x(i,j)>0.5));
        end
    end
    y=x(m1+1:m+m1, n1+1:n+n1)>0.5;
    
 end
    
endfunction
