function y = skeleton( x )

I = double(x);
[m n] = size(I);

//     p1 p2 p3 p4 p5 p6 p7 p8 p9  p2
    px = [0  0  1  1  1  0  -1 -1 -1  0 ];
    py = [0 -1  -1 0  1  1   1 0  -1  -1];


// repeat until no more pixels can be flagged for deletion

 while 1
     
        // Find contour points
 C=findContour(I,1);
        
        // Mark for deletion
        D = zeros(m, n);
        
        // first pass
        for j=2:m-1
            for i=2:n-1
                    
                // condition (a)  2<= N(p) <= 6
                N = 0;
                if (C(j,i) > 0)
                    for s=2:9,
                        N=N+I(j+px(s), i+py(s));
                    end
                end  
                    
                if (N>=2) & (N<=6)
                    
                    // condition (b)
                    S = 0;
                    for s=2:9,
                        if (I(j+px(s),i+py(s)) == 0) & (I(j+px(s+1), i+py(s+1))>0)
                            S = S+1;
                        end
                    end
                    
                    if (S==1)
                        
                        // condition C
                        if ((I(j+px(2),i+py(2)) * I(j+px(4),i+py(4)) * I(j+px(6),i+py(6)))==0)
                            
                            // condition D
                            if ((I(j+px(4),i+py(4)) * I(j+px(6),i+py(6)) * I(j+px(8),i+py(8)))==0)
                                
                                // mark this pixel for deletion!
                                D(j,i) = 1;
                                
                            end //condition (d)
                        end //condition (c)    
                    end //condition (b)               
                end // condition (a)
            
            
            end
            
        end // for j       
       
       
        // delete marked pixels from pass 1
        I = I .* ~D;
        
        // Find contour points
        C = zeros(m, n);
        for j=2:m-1
            for i=2:n-1
                if (I(j,i)>0)
                    sm = 0; //
                    for s=-1:1
                        for t=-1:1
                            if (I(j+s,i+t)==0)
                                C(j,i) = C(j,i) + 1;
                            end
                        end
                    end //for s
                end // if
                
            end
        end // for j
        
        
        DD = zeros(m, n);
        
        // second pass
        
        for j=2:m-1
            for i=2:n-1
                    
                 // condition (a)  2<= N(p) <= 6
                N = 0;
                if (C(j,i) > 0)
                    for s=2:9,
                        N=N+I(j+px(s), i+py(s));
                    end
                end
                 
                if (N>=2) & (N<=6)
             
                    // condition (b)
                    S = 0;
                    for s=2:9
                        if (I(j+px(s),i+py(s)) == 0) & (I(j+px(s+1), i+py(s+1))>0)
                            S = S+1;
                        end
                    end
                    if (S==1)
                        // condition C
                        if ((I(j+px(2),i+py(2)) * I(j+px(4),i+py(4)) * I(j+px(8),i+py(8)))==0)
                            
                            // condition D
                            if ((I(j+px(2),i+py(2)) * I(j+px(6),i+py(6)) * I(j+px(8),i+py(8)))==0)
                                
                                // mark this pixel for deletion!
                                DD(j,i) = 1;
                                
                            end //condition (d)
                        end //condition (c)
                    end //condition (b)
                end // condition (a)
                
            end
        end // for j       
    
         // delete marked pixels from pass 2
        I = I .* ~DD;
        
        D = D + DD;
  
        if (unique(D) == 0)
            break;
        end
    end
      
    y = I;

endfunction
